.\" -*- nroff -*-
.\"
.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VOP_FSYNC.9,v 1.1.2.3 1999/09/05 11:27:12 peter Exp $
.\"
.Dd July 24, 1996
.Os
.Dt VOP_FSYNC 9
.Sh NAME
.Nm VOP_FSYNC
.Nd flush filesystem buffers for a file
.Sh SYNOPSIS
.Fd #include <sys/vnode.h>
.Ft int
.Fn VOP_FSYNC "struct vnode *vp" "struct ucred *cred" "int waitfor" "struct proc *p"
.Sh DESCRIPTION
This call flushes any dirty filesystem buffers for the file.
It is used to implement the
.Xr sync 2
and
.Xr fsync 2
system calls.
.Pp
Its arguments are:
.Bl -tag -width waitfor
.It Ar vp
the vnode of the file
.It Ar cred
the caller's credentials
.It Ar waitfor
whether the function should wait for I/O to complete
.It Ar p
the calling process
.El
.Pp
The argument
.Fa waitfor
is either
.Dv MNT_WAIT
or
.Dv MNT_NOWAIT
and specifies whether or not the function should wait for the writes
to finish before returning.
.Sh LOCKS
The file should be locked on entry.
.Sh RETURN VALUES
Zero is returned if the call is successful, otherwise an appropriate
error code is returned.
.Sh PSEUDOCODE
.Bd -literal
int
vop_fsync(struct vnode *vp, struct ucred *cred, int waitfor, struct proc *p)
{
    struct buf *bp;
    struct buf *nbp;
    struct timeval tv;
    int s;

loop:
    s = splbio();
    for (bp = vp->v_dirtyblkhd.lh_first; bp; bp = nbp) {
	nbp = bp->b_vnbufs.le_next;

	/*
	 * Ignore buffers which are already being written.
	 */
	if (bp->b_flags & B_BUSY)
	    continue;
	
	/*
	 * Make sure the buffer is dirty.
	 */
	if ((bp->b_flags & B_DELWRI) == 0)
	    panic("vop_fsync: not dirty");

	vfs_bio_awrite(bp);
	splx(s);
	goto loop;
    }
    splx(s);

    if (waitfor == MNT_WAIT) {
	s = splbio();
	while (vp->v_numoutput) {
	    vp->v_flag |= VBWAIT;
	    tsleep((caddr_t)&vp->v_numoutput, PRIBIO + 1, "vopfsn");
	}
	splx(s);
#ifdef DIAGNOSTIC
	if (vp->v_dirtyblkhd.lh_first) {
	    vprint("vop_fsync: dirty", vp);
	    goto loop;
	}
#endif
    }

    /*
     * Write out the on-disc version of the vnode.
     */
    tv = time;
    return VOP_UPDATE(vp, &tv, &tv, waitfor == MNT_WAIT);
}
.Ed
.Sh ERRORS
.Bl -tag -width Er
.It Bq Er ENOSPC
The filesystem is full.
.It Bq Er EDQUOT
Quota exceeded.
.El
.Sh SEE ALSO
.Xr vnode 9
.Sh AUTHORS
This man page was written by Doug Rabson.

